﻿#pragma once

#include <string>
#include "..\DeviceResources.h"
#include "..\Common\StepTimer.h"
#include "Paragraph.h"
#include "Page.h"
#include "FirstLineIndent.h"

namespace PaginationExperiment6
{
	class PaginationExperiment6Renderer
	{
	public:
		PaginationExperiment6Renderer(const std::shared_ptr<DeviceResources>& deviceResources);
		void CreateDeviceDependentResources();
		void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
        void Update(DX::StepTimer const& timer);
		bool Render();

        // Methods called from PagainationExperiment1Main
        void SetBookText(std::vector<std::wstring> lines);
        void ScrollHorizontalDelta(float deltaX);
        void ClearPages();

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

        std::vector<Paragraph> m_paragraphs;
        std::vector<Page> m_pages;
        void PaginateBook();
        bool AddParagraphToPage(Page& page, Paragraph& paragraph, float x, float& y, float maxY, bool& isSplit);
        void MakePageUniformHeight(Page& page, float desiredHeight);

        bool m_needsRedraw;
        float m_currentScroll;
        float m_maximumScroll;
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
		Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
        Microsoft::WRL::ComPtr<IDWriteTextFormat>       m_textFormatPageNumber;
        Microsoft::WRL::ComPtr<IDWriteTextFormat>       m_textFormatStatus;
    };
}